clear all;
qntTerms=[100];
for t=1:size(qntTerms,2),
	fileName = ['rnasResults_' num2str(qntTerms(t)) 'T.txt'];
	diary (fileName)
	date=clock;
	disp(['Data: ' num2str(date(3)) '/' num2str(date(2)) ' - ' num2str(date(4)) ':' num2str(date(5))]);
    disp(['Num. de termos: ' num2str(qntTerms(t))]);
    
	numFolds = 10;
    totalTieme=tic;
	for i=1:numFolds,
		eval(['load balanced_fold_' num2str(i) '_' num2str(qntTerms(t)) 'T']);
		disp('=================================================================');
		disp(['Estou no fold    	: ' num2str(i)]);
		ac_base=0;     
		
		%rede
		nhidden=[15 27 30 35 39 55];
		for z=1:size(nhidden,2),% varia o nro de neuronios na camada oculta
			numHiddenNeurons = nhidden(z);
			disp(['O numero de neuronios ocultos     	: ' num2str(nhidden(z))]);
			for j=1:3,%3 repeties do treino e teste
				disp(['Essa  a repetio     	: ' num2str(j)]);
				net = newpr(tdmTrainTFIDFDesb,tn,numHiddenNeurons);            
		  
				net.trainParam.goal=0.001;
				net.trainParam.epochs=200;
				net.divideParam.trainRatio = 0.9;
				net.divideParam.valRatio=0.1;
				net.divideParam.testRatio=0;				
				
				trainTime = tic;
				net = train(net,tdmTrainTFIDFDesb,tn);
				tempo = toc(trainTime);
				
				disp(['Tempo: ' num2str(tempo)]);
		
				TP=0; FP=0; TN=0; FN=0;
				for y=1:size(tes_tn,2),
					An = compet(sim(net,tdmTestTFIDF(:,y)));
					if (tes_tn(:,y)'==([1 0])) % negativos
						if (An(1,1)==1 & An(2,1)==0) 
							TN = TN+1;
						else
							FP=FP+1; 
						end;
					else   %positivos
						if (An(1,1)==0 & An(2,1)==1)
							TP = TP+1;
						else
							FN=FN+1;           
						end;
					end;
				end; 
				accuracy=(TP+TN)/(TP+FP+FN+TN);            
				disp(['Minha acuracia foi  	: ' num2str(accuracy)]);
				if (accuracy > ac_base),
					ac_base = accuracy;				
					disp(['Ultrapassei 80% de acerto   	: ' num2str(accuracy)]);
					eval(['save cr_fold' num2str(i) '_NET_' num2str(qntTerms(t)) 'T' ' net']);
					tempoFold =tempo;
					recall_neg=TN/(TN+FP);
					recall_pos=TP/(TP+FN);
					precision_neg=TN/(TN+FN);
					precision_pos=TP/(TP+FP);
					fmeasure_neg=2*recall_neg*precision_neg/(recall_neg+precision_neg);
					fmeasure_pos=2*recall_pos*precision_pos/(recall_pos+precision_pos);
					proporcao_neg = sum(tes_tn(1,:)==1)/size(tes_tn,2);
					proprocao_pos = sum(tes_tn(2,:)==1)/size(tes_tn,2);
					overall_recall= (proporcao_neg*recall_neg)+(proprocao_pos*recall_pos);
					overall_precision= (proporcao_neg*precision_neg)+(proprocao_pos*precision_pos);
					overall_fmeasure= (proporcao_neg*fmeasure_neg)+(proprocao_pos*fmeasure_pos);
					oR=overall_recall;
					oP=overall_precision;
					oFm=overall_fmeasure;
				end;
			end;
		end;
		best_time(i)=tempoFold;
		best_ac(i)=ac_base;
		best_rec_pos(i)= recall_pos;
		best_rec_neg(i)= recall_neg;
		best_prec_pos(i) = precision_pos; 
		best_prec_neg(i) = precision_neg;
		best_fmeans_pos(i) = fmeasure_pos;
		best_fmeans_neg(i) = fmeasure_neg;
		best_oR(i)=oR;
		best_oP(i)=oP;
		best_oFm(i)=oFm;
	end;
	disp(['   ']);
	disp('=================================================================');
	disp(['Acuracia Geral Media  : ' num2str(sum(best_ac)/numFolds)  ' +/-STD : ' num2str(std(best_ac))]);
	disp(['   ']);
	disp(['Recall Geral Media    : ' num2str(sum(best_oR)/numFolds)  ' +/-STD : ' num2str(std(best_oR))]);
	disp(['Recall POS Media      : ' num2str(sum(best_rec_pos)/numFolds)  ' +/-STD : ' num2str(std(best_rec_pos))]);
	disp(['Recall NEG Media      : ' num2str(sum(best_rec_neg)/numFolds)  ' +/-STD : ' num2str(std(best_rec_neg))]);
	disp(['   ']);
	disp(['Precision Geral Media : ' num2str(sum(best_oP)/numFolds)  ' +/-STD : ' num2str(std(best_oP))]);
	disp(['Precision POS Media   : ' num2str(sum(best_prec_pos)/numFolds)  ' +/-STD : ' num2str(std(best_prec_pos))]);
	disp(['Precision NEG Media   : ' num2str(sum(best_prec_neg)/numFolds)  ' +/-STD : ' num2str(std(best_prec_neg))]);
	disp(['   ']);
	disp(['Fmeasure Geral Media  : ' num2str(sum(best_oFm)/numFolds) ' +/-STD : ' num2str(std(best_oFm))]);
	disp(['Fmeasure POS Media    : ' num2str(sum(best_fmeans_pos)/numFolds) ' +/-STD : ' num2str(std(best_fmeans_pos))]);
	disp(['Fmeasure NEG Media    : ' num2str(sum(best_fmeans_neg)/numFolds) ' +/-STD : ' num2str(std(best_fmeans_neg))]);
	disp(['   ']);
	disp(['Tempo Medio           : ' num2str(sum(best_time)/numFolds)]);
	
	disp(['   ']);
    tempoTotal=toc(totalTieme);
	disp(['Tempo total do experimento: ' num2str(tempoTotal)]);
    disp(['   ']);
	
	diary off
end;