
clear all;
disp('=================================================================');
numTermosIG = 100; 
proporcoes = [0.2 0.4 0.6 0.8];

load Idx10Fold;
load fullBase;

dicFull = cellstr(dictionary);
tdmFreq = full(A);
tdmBin = tdmFreq>0;
tdmFull = tdmBin;
ids = [Idx' Idx'];

numTermosFull = size(tdmFull,1);
numDocsFull = size(tdmFull,2);

disp(strcat('Quantidade de termos IG: ', num2str(numTermosIG)));

disp(strcat('Comeou'));
    
for i = 1 : 10
    for prop = 1 : size(proporcoes,2)
    
    idTest = false(1,numDocsFull);
    idTest(:, ids == i) = true;
    tdmTest = tdmBin(:,idTest);
    tdmTestFreq = tdmFreq(:,idTest);
    idTrain = ~idTest;
    tdmTrain = tdmBin(:,idTrain);
    tdmTrainFreq = tdmFreq(:,idTrain);
    
    numDocsTrainBal = size(tdmTrain,2);
    
    numDocsTrainPos = numDocsTrainBal/2;
    numDocsTrainNeg = numDocsTrainBal/2*proporcoes(prop);
    
    numDocsTrainDesb = numDocsTrainPos+numDocsTrainNeg;
    
    iNEGTrain = false(1,numDocsTrainDesb);  
    iPOSTrain = false(1,numDocsTrainDesb);
    iNEGTrain(1:numDocsTrainNeg) = true;
    iPOSTrain(numDocsTrainNeg + 1 : end) = true;
    
    
    numDocsTest = size(tdmTest,2);
    iNEGTest = false(1,numDocsTest);  
    iPOSTest = false(1,numDocsTest);
    iNEGTest(1:numDocsTest/2) = true;
    iPOSTest((numDocsTest/2) + 1 : end) = true;
        
    tdmTrainDesb = [tdmTrain(:,1:numDocsTrainNeg) tdmTrain(:,(numDocsTrainPos+1):end)];
    tdmTrainFreqDesb = [tdmTrainFreq(:,1:numDocsTrainNeg) tdmTrainFreq(:,(numDocsTrainPos+1):end)];
    
    %-- Tratar termos teste X treino
    idTermosAusentesTrain = full(sum(tdmTrainDesb,2) == 0);
    idTermosAusentesTest = full(sum(tdmTest,2) == 0);
    
    tdmTrainDesb(idTermosAusentesTrain,:) = [];
    tdmTrainFreqDesb(idTermosAusentesTrain,:) = [];
    
    numTermosTrain = size(tdmTrainDesb,1);

    
    dicTrain = dicFull(~idTermosAusentesTrain);
    dicTest = dicFull(~idTermosAusentesTest);


    contagem_termos_neg = sum(tdmTrainDesb(:,iNEGTrain),2); % total de docs negativos em que o termo aparece
    contagem_termos_pos = sum(tdmTrainDesb(:,iPOSTrain),2); % total de docs positivos em que o termo aparece

    contagem_termos = sum(tdmTrainDesb,2);
    Pt = (contagem_termos + 1) / (numDocsTrainDesb + 2);
    Pt_neg = (contagem_termos_neg + 1) ./ (contagem_termos + 2);
    Pt_pos = (contagem_termos_pos + 1) ./ (contagem_termos + 2);

    contagem_termos_not_neg = (numDocsTrainNeg)-sum(tdmTrainDesb(:,iNEGTrain),2); % total de docs negativos em que o termo NO aparece
    contagem_termos_not_pos = (numDocsTrainPos)-sum(tdmTrainDesb(:,iPOSTrain),2); % total de docs positivos em que o termo NO aparece
    contagem_termos_not = numDocsTrainDesb - sum(tdmTrainDesb,2);

    Pt_not = (contagem_termos_not + 1)/ (numDocsTrainDesb + 2);
    Pt_not_neg = (contagem_termos_not_neg + 1) ./ (contagem_termos_not + 2);
    Pt_not_pos = (contagem_termos_not_pos + 1)./ (contagem_termos_not + 2);

    Pneg = numDocsTrainNeg/numDocsTrainDesb;
    Ppos= numDocsTrainPos/numDocsTrainDesb;
    e = (Pneg*log2(1/Pneg) + Ppos*log2(1/Ppos));

    um = ones(numTermosTrain,1);

    IG = e - ...
        ((Pt.*((Pt_neg.*log2(um./Pt_neg)) + (Pt_pos.*log2(um./Pt_pos)))) ...
        + (Pt_not.*( (Pt_not_neg.*log2(um./Pt_not_neg)) + (Pt_not_pos.*log2(um./Pt_not_pos)))));
    
    [IGs,sidx] = sort(IG,'descend'); 
    
  
    wTrain_IG = IG(sidx(1:numTermosIG));
    wTrain_IG_mat = repmat(wTrain_IG,1,numDocsTrainDesb);
    wTest_IG_mat = repmat(wTrain_IG,1,numDocsTest);
    %----- tdm_IG: termos x docs
    tdmTrain_IG = tdmTrainDesb(sidx(1:numTermosIG),:);
    
    tdmTrainFreqDesb = tdmTrainFreqDesb(sidx(1:numTermosIG),:);
    dicTrain = dicTrain(sidx(1:numTermosIG),:);
    
    %--- Atribui pesos IG
    tdm_wIG_Train_IG =  tdmTrain_IG .* wTrain_IG_mat;
    
    
    %--- fica somente com os termos presentes no treino (elimina do teste os termos ausentes no treino)
    tdmTest(idTermosAusentesTrain,:) = [];
    tdmTestFreq(idTermosAusentesTrain,:) = [];
    
    tdmTest_IG = tdmTest(sidx(1:numTermosIG),:);
    tdmTestFreq = tdmTestFreq(sidx(1:numTermosIG),:);
    
    tdm_wIG_Test_IG =  tdmTest_IG .* wTest_IG_mat;   
    

    opinioes_treino_sem_termos = sum(sum(tdmTrain_IG) == 0);

    %----- cdm: linha 1 = negativos ; linha 2: positivos 
    cdm = double([iNEGTrain;iPOSTrain]);
    cdmTeste = double([iNEGTest;iPOSTest]);

    
    tn = full(cdm);

    tes_tn = full(cdmTeste);   
    
    
    pn_Bin = full(tdmTrain_IG);
    tes_pn_Bin = full(tdmTest_IG);
    
    tdmTestFreq = full(tdmTestFreq);
    tdmTrainFreqDesb = full(tdmTrainFreqDesb);
    
    
    
    for k=1:numTermosIG
        pesos_IDF(k)=log(numDocsTrainDesb/sum(pn_Bin(k,:)));
    end
    pesos_IDF_transp = pesos_IDF';
        
    tdmTrainTFIDFDesb = tdmTrainFreqDesb.*repmat(pesos_IDF_transp,1,numDocsTrainDesb);

    tdmTestTFIDF = tdmTestFreq.*repmat(pesos_IDF_transp,1,numDocsTest);

    nomearq = strcat('imbalanced_fold_',num2str(i),'_',num2str(numTermosIG),'T_',num2str(numDocsTrainNeg),'DocsNeg');
    save(nomearq,'tn', 'tes_tn', 'IGs','numTermosIG','tdmTrainTFIDFDesb','tdmTestTFIDF', 'tdmTestFreq','tdmTrainFreqDesb','dicTrain');
    
    disp(strcat('Fold_',num2str(i)));   
    
    end
end
disp('=================================================================');







 

 
 