clear all;
qntTerms=[100];
propDesb=[720,540,360,180];
for t=1:size(qntTerms,2),
    for prop=1:size(propDesb,2)
        fileName = ['bayesMultiResults_' num2str(qntTerms(t)) 'T_' num2str(propDesb(prop)) 'neg.txt'];
        diary (fileName)
        date=clock;
        disp(['Data: ' num2str(date(3)) '/' num2str(date(2)) ' - ' num2str(date(4)) ':' num2str(date(5))]);

        numFolds = 10;
        totalTieme=tic;

        for i=1:numFolds,
            eval(['load imbalanced_fold_' num2str(i) '_' num2str(qntTerms(t)) 'T_' num2str(propDesb(prop)) 'DocsNeg']);
            disp('=================================================================');
            disp(['Estou no fold    	: ' num2str(i)]);
            best=0;

            TP=0;TN=0;FP=0;FN=0;

            disp(['   ']);
            disp(['Treino:']);
            trainTime = tic;   
			
			% here we are using the NaiveBayes Matlab class. Ref.: https://www.mathworks.com/help/stats/naivebayes-class.html
            nb=NaiveBayes.fit(tdmTrainFreqDesb',tn(2,:)','dist','mn');            
            tempo = toc(trainTime); 
            disp(['Tempo: ' num2str(tempo)]);
            disp(['Teste: ']);        
            predict_label=predict(nb,tdmTestFreq');
          

        TNtemp = sum(predict_label(1:100,1)==0);
		TPtemp = sum(predict_label(101:200,1)==1);
		FPtemp = (sum(predict_label(1:100,1)==1));
		FNtemp = (sum(predict_label(101:200,1)==0));


            TN=TNtemp;
            TP=TPtemp;
            FP=FPtemp;
            FN=FNtemp;

            best=((TN+TP)/(TN+TP+FN+FP));

            tempoFold =tempo;

            eval(['save test_desbal_neg_cr_fold' num2str(i) '_BayesMulti_' num2str(qntTerms(t)) 'T_' num2str(propDesb(prop)) ' nb']);

            recall_neg=TN/(TN+FP);
            recall_pos=TP/(TP+FN);
            if(TN==0)
                precision_neg=0;
                fmeasure_neg=0;
            else
                precision_neg=TN/(TN+FN);
                fmeasure_neg=2*recall_neg*precision_neg/(recall_neg+precision_neg);
            end
            if(TP==0)
                precision_pos=0;
                fmeasure_pos=0;
            else
                precision_pos=TP/(TP+FP);
                fmeasure_pos=2*recall_pos*precision_pos/(recall_pos+precision_pos);
            end         
            
            
            proporcao_neg = sum(tes_tn(1,:)==1)/size(tes_tn,2);
            proprocao_pos = sum(tes_tn(2,:)==1)/size(tes_tn,2);
            overall_recall= (proporcao_neg*recall_neg)+(proprocao_pos*recall_pos);
            overall_precision= (proporcao_neg*precision_neg)+(proprocao_pos*precision_pos);
            overall_fmeasure= (proporcao_neg*fmeasure_neg)+(proprocao_pos*fmeasure_pos);

            best_time(i)=tempoFold;
            best_ac(i)=best;
            best_rec_pos(i)= recall_pos;
            best_rec_neg(i)= recall_neg;
            best_prec_pos(i) = precision_pos; 
            best_prec_neg(i) = precision_neg;
            best_fmeans_pos(i) = fmeasure_pos;
            best_fmeans_neg(i) = fmeasure_neg;			
            best_oR(i)=overall_recall;
            best_oP(i)=overall_precision;
            best_oFm(i)=overall_fmeasure;

            disp(['                                       ']);
            disp(['Minha acuracia de teste foi  	     : ' num2str(best)]);
            disp(['Overall Precision 	     : ' num2str(overall_precision)]);
            disp(['Overall Recall            : ' num2str(overall_recall)]);
            disp(['Tempo: ' num2str(tempoFold)]);	
        end;	
	disp(['   ']);
	disp('=================================================================');
	disp(['Acuracia Geral Media  : ' num2str(sum(best_ac)/numFolds)  ' +/-STD : ' num2str(std(best_ac))]);
	disp(['   ']);
	disp(['Recall Geral Media    : ' num2str(sum(best_oR)/numFolds)  ' +/-STD : ' num2str(std(best_oR))]);
	disp(['Recall POS Media      : ' num2str(sum(best_rec_pos)/numFolds)  ' +/-STD : ' num2str(std(best_rec_pos))]);
	disp(['Recall NEG Media      : ' num2str(sum(best_rec_neg)/numFolds)  ' +/-STD : ' num2str(std(best_rec_neg))]);
	disp(['   ']);
	disp(['Precision Geral Media : ' num2str(sum(best_oP)/numFolds)  ' +/-STD : ' num2str(std(best_oP))]);
	disp(['Precision POS Media   : ' num2str(sum(best_prec_pos)/numFolds)  ' +/-STD : ' num2str(std(best_prec_pos))]);
	disp(['Precision NEG Media   : ' num2str(sum(best_prec_neg)/numFolds)  ' +/-STD : ' num2str(std(best_prec_neg))]);
	disp(['   ']);
	disp(['Fmeasure Geral Media  : ' num2str(sum(best_oFm)/numFolds) ' +/-STD : ' num2str(std(best_oFm))]);
	disp(['Fmeasure POS Media    : ' num2str(sum(best_fmeans_pos)/numFolds) ' +/-STD : ' num2str(std(best_fmeans_pos))]);
	disp(['Fmeasure NEG Media    : ' num2str(sum(best_fmeans_neg)/numFolds) ' +/-STD : ' num2str(std(best_fmeans_neg))]);
	disp(['   ']);
	disp(['Tempo Medio           : ' num2str(sum(best_time)/numFolds)]);
	
	disp(['   ']);
    tempoTotal=toc(totalTieme);
	disp(['Tempo total do experimento: ' num2str(tempoTotal)]);
    disp(['   ']);
	
	diary off
    end;
end;
        
        
        
        
        
        
        
        